=== debian/changelog ===
kmymoney (4.5-2) experimental; urgency=low

  * Add Build-Depends: pkg-config
    - Fixes "onlinebanking not compiled in" (Closes: #594553)

 -- Mark Purcell <msp@debian.org>  Tue, 21 Sep 2010 21:31:40 +1000

kmymoney (4.5-1) experimental; urgency=low

  * New upstream release

 -- Mark Purcell <msp@debian.org>  Sat, 21 Aug 2010 17:35:20 +1000
